#.rst:
# ECMSourceVersionControl
# --------------------------
#
# Tries to determine whether the source is under version control (git clone,
# svn checkout, etc).
#
# ``ECM_SOURCE_UNDER_VERSION_CONTROL`` is set when indication is found that
# CMAKE_SOURCE_DIR is under version control.
#
# Since 5.63

#=============================================================================
# Copyright 2019 Harald Sitter <sitter@kde.org>
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. The name of the author may not be used to endorse or promote products
#    derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

if(EXISTS "${CMAKE_SOURCE_DIR}/.git" OR
   EXISTS "${CMAKE_SOURCE_DIR}/.svn" OR
   EXISTS "${CMAKE_SOURCE_DIR}/.hg" OR
   EXISTS "${CMAKE_SOURCE_DIR}/.bzr")
    set(ECM_SOURCE_UNDER_VERSION_CONTROL TRUE)
else()
    set(ECM_SOURCE_UNDER_VERSION_CONTROL FALSE)
endif()
